//
// File:        AudioServer.java
// Author:      Tomasz Stachowiak
// e-mail:      <stach@npac.syr.edu>
// Created:     Tue Jan 28 1997
// Time-stamp: <97/01/29 17:20:30 stach>
// Copyright Tomasz Stachowiak 1997 NPAC, Syracuse University

// Description: Audio server transmiting all the audio packages 
//              from Audio Senders to all the AudioLive applets
//              Server manages the active user also 

import java.awt.*;
import java.util.*;
import java.net.*;

public class AudioServer extends Frame {

  AudioClient client;
  Thread clientThread;

  AudioListener listener;
  Thread listenerThread;

  List memberList;
  Hashtable members;

  public AudioServer() {
    setTitle("Audio Server");
    
    Panel p1 = new Panel();
    memberList = new List(5, false);
    p1.add(memberList);

    add("South", p1);

    initNet();
  }

  private void initNet() {
    members = new Hashtable();

    client = new AudioClient(members, memberList);
    clientThread = new Thread(client);

    listener = new AudioListener(members, 1600);
    listenerThread = new Thread(listener);

    clientThread.start();
    listenerThread.start();
  }

  public boolean handleEvent(Event evt) {
    if(evt.id == Event.WINDOW_DESTROY) {
      clientThread.stop();
      listenerThread.stop();
      System.exit(0);
    }
    return super.handleEvent(evt);
  }

  public static void main(String argv[]) {
    Frame f = new AudioServer();
    f.resize(170, 170);
    f.show();
  }
}

